//---------------------------------------------------------------------------
// echo server
// quick and dirty echo server to demo multiple zsockets

// echos all data received from clients back to them
// creates a new instance of zsocket for each new client that
// trys to connect

// uses addrsss 127.0.0.1 the local loopback, you can run the server and
// client on the same system, or modify the clients IP address to run them
// over a network or internet.

// we also setup a class called handler. You will do something similar
// to implement your multi client code.

#include <vcl\vcl.h>
#pragma hdrstop

#include "servunit.h"
//---------------------------------------------------------------------------
#pragma link "zsocket"
#pragma link "Grids"
#pragma resource "*.dfm"

TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
int	i;

	for (i=0; i<100; i++) clients[i] = 0; // clear list of connected clients
    conn_count = 1;
}
//---------------------------------------------------------------------------
// here we create a new ZSocket instance to handle the new client
// that wants to connect
void __fastcall TForm1::ZSocket1ConnectionRequest(TObject *Sender)
{
Handler		*hand1;
TZSocket	*socket1;
int			i;
char		str[256];

// create new ZSocket, setup the event handlers
// we use a class called handler to implement the code
// to handle whatever the client is going to need
// as an example, if this were a FTP server, we would create
// a class FTPHandler that would implement the FTP

	hand1 = new Handler();
    socket1 = new TZSocket(this);
    socket1->ListenSocketHandle = ZSocket1->ListenSocketHandle;
// set event handlers
    socket1->OnDataAvailable = hand1->HandDataAvailable;
    socket1->OnClose = hand1->HandClose;

// accept the new client with the new zsocket

    socket1->ZAccept();
    hand1->remote_IP = socket1->PeerAddr;

// setup the handler vars

	i = 0;
	while (clients[i] != 0 && i < 100) i++;
    clients[i] = conn_count; 		// CONN NUMBER ASSIGED to this client

    hand1->client = conn_count;
    hand1->aStringGrid = StringGrid1;
    hand1->client_list = clients;

// show the IP address of the client that just connected
    StringGrid1->Cells[1][i] = socket1->PeerAddr;
    sprintf(str, "%d", conn_count);
    conn_count++;
    StringGrid1->Cells[0][i] = str;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	ZSocket1->ZListen();
}

__fastcall Handler::Handler()
{

}

void __fastcall Handler::HandDataAvailable(TObject *Sender)
{
AnsiString as;
TZSocket *aZSocket = ((TZSocket*)Sender);

// echo anything the client sends back to them

	as = aZSocket->Text;  // get it
    aZSocket->Text = as;  // send it out           	
    // or test the ZSend method below
    //aZSocket->ZSend(aZSocket->SocketHandle,(unsigned char *)as.c_str(), as.Length());
}
void __fastcall Handler::HandClose(TObject *Sender)
{
int	i = 0;

// clear the client that is listed in the string grid

		aStringGrid->Cells[0][client-1] = "";
        aStringGrid->Cells[1][client-1] = "";

        while (client_list[i] != client && i < 100) i++;
        client_list[i] = 0;
}
//---------------------------------------------------------------------------


